package cc.smtweb.system.bpm.web.engine.model.flow.listcard.single;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwConsts;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.db.impl.DefaultEntity;
import cc.smtweb.framework.core.db.vo.ModelTable;
import cc.smtweb.framework.core.exception.BizException;
import cc.smtweb.framework.core.mvc.service.SwListData;
import cc.smtweb.system.bpm.web.design.flow.FlowConst;
import cc.smtweb.system.bpm.web.design.form.ModelForm;
import cc.smtweb.system.bpm.web.design.form.ModelFormHelper;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageListHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynRetBean;
import cc.smtweb.system.bpm.web.engine.flow.FlowHelper;
import cc.smtweb.system.bpm.web.engine.flow.FlowInstance;
import cc.smtweb.system.bpm.web.engine.flow.FlowListener;
import cc.smtweb.system.bpm.web.engine.flow.FlowProvider;
import cc.smtweb.system.bpm.web.engine.model.listcard.single.LCSingleHelper;
import cc.smtweb.system.bpm.web.engine.model.listcard.single.LCSingleLoadHandler;

import java.util.ArrayList;

/**
 * Created by Akmm at 2022-08-26 17:15
 */
public class FlowSingleLoadHandler<T extends DefaultEntity> extends LCSingleLoadHandler implements FlowListener {
    protected FlowInstance flowInstance;

    @Override
    protected void afterAdd(SwMap ret, SwMap bean) {
        FlowInstance flowInstance = new FlowInstance(this, us);
        flowInstance.create(form.getBillType());

        PageDataset cardDataset = LCSingleHelper.findCardDataset(datasets);
        ModelTable table = cardDataset.getModelTable();
        bean.put(table.getIdField(), flowInstance.getProcInst().getId());

        ret.put(FlowHelper.DATASET_NAME_FLOW, DynRetBean.createBean(flowInstance.getProcInst()));
        ret.put(FlowHelper.DATASET_NAME_COMMENT, DynRetBean.createList(SwListData.EMPTY));
    }

    @Override
    public R load() {
        SwMap ret = new SwMap();
        //过滤条件
        long id = params.readLong("id");
        long taskId = params.readLong("taskId");
//        SwMap filter = params.readMap("filter");
        SwMap filter = new SwMap();
        filter.put(SwConsts.NAME_ID, id);
        //对应的数据集定义
        PageDataset cardDataset = LCSingleHelper.findCardDataset(datasets);

        SwMap data = provider.loadData(filter, cardDataset);
        ret.put(cardDataset.name, data);

        //加载流程信息
        FlowInstance flowInstance = new FlowInstance(this, us);
        flowInstance.load(id, taskId);

        ret.put(FlowHelper.DATASET_NAME_FLOW, DynRetBean.createBean(flowInstance.getProcInst()));
        ret.put(FlowHelper.DATASET_NAME_COMMENT, DynRetBean.createList(SwListData.create(flowInstance.loadComment(), 0)));
        
        afterLoad(ret, data);
        return R.success(ret);
    }

    @Override
    protected DynPageListHandler getListWorker(SwMap filter, PageDataset pageDataSet) {
        FlowListHandler listHandler = new FlowListHandler(form.getId(), filter, pageDataSet);
        listHandler.init(params, us);
        return listHandler;
    }
}
