package cc.smtweb.system.bpm.web.engine.model.listcard.mastersub;

import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.engine.model.listcard.single.LCSingleService;

/**
 * @Author:lip
 * @Date : 2022/8/28 20:38
 */
@SwService
public class LCMsService extends LCSingleService {
    private final static String TYPE_MODEL_LIST = "modelList";
    private final static String TYPE_MODEL_ADD = "modelAdd";
    private final static String TYPE_MODEL_LOAD = "modelLoad";
    private final static String TYPE_MODEL_SAVE = "modelSave";
    private final static String TYPE_MODEL_DEL = "modelDel";

    @Override
    protected AbstractHandler createHandler(String type) {
        switch (type) {
            case TYPE_MODEL_LIST:
            case TYPE_MODEL_LOAD:
            case TYPE_MODEL_ADD:
                return new LCMsLoadHandler();
            case TYPE_MODEL_SAVE:
                return new LCMsSaveHandler();
            case TYPE_MODEL_DEL:
                return new LCMsDelHandler();
        }
        return super.createHandler(type);
    }

    //保存
    public R modelSave(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_SAVE, handler -> ((LCMsSaveHandler)handler).save());
    }

    //读取
    public R modelLoad(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LOAD, handler -> ((LCMsLoadHandler)handler).load());
    }

    //读取
    public R modelAdd(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_ADD, handler -> ((LCMsLoadHandler)handler).add());
    }

    //删除
    public R modelDel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_DEL, handler -> ((LCMsDelHandler)handler).del());
    }

    //列表数据
    public R modelList(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCMsLoadHandler)handler).list());
    }

    //列表总记录数及合计栏
    public R modelListTotal(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCMsLoadHandler)handler).getTotal());
    }
}
