package cc.smtweb.system.bpm.web.engine.model.listcard.normal;

import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.engine.model.listcard.single.LCSingleService;

/**
 * @Author:lip
 * @Date : 2022/8/27 13:54
 */
@SwService
public class LCNormalService extends LCSingleService {
    @Override
    protected AbstractHandler createHandler(String type) {
        switch (type) {
            case TYPE_MODEL_LIST:
            case TYPE_MODEL_LOAD:
            case TYPE_MODEL_ADD:
                return new LCNormalLoadHandler();
            case TYPE_MODEL_DEL:
                return new LCNormalDelHandler();
        }
        return super.createHandler(type);
    }

    //删除
    public R modelDel(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_DEL, handler -> ((LCNormalDelHandler)handler).del());
    }

    //读取
    public R modelLoad(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LOAD, handler -> ((LCNormalLoadHandler)handler).load());
    }

    //读取
    public R modelAdd(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_ADD, handler -> ((LCNormalLoadHandler)handler).add());
    }

    //列表数据
    public R modelList(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCNormalLoadHandler)handler).list());
    }

    //列表总记录数及合计栏
    public R modelListTotal(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_MODEL_LIST, handler -> ((LCNormalLoadHandler)handler).getTotal());
    }
}
