{
  "version": 6,
  "form": [
    {
      "page": {
        "id": "id${newId()}",
        "type": "fx-page",
        "props": {
          "title": "${title}",
          "key": "${newId()}",
          "tipsExpand": false
        }
      },
      "graph": {
        "shape": "panel",
        "id": "root_panel",
        "type": "fx-split-panel",
        "props": {
          "horizontal": false,
          "shadow": ""
        },
        "children": [
          {
            "id": "${newId()}",
            "type": "fx-split-panel",
            "shape": "panel",
            "props": {
              "horizontal": false,
              "scroll": true
            },
            "children": [
                {
                    "id": "${newId()}",
                    "type": "fx-split-panel",
                    "shape": "panel",
                    "props": {
                        "size": "60"
                    },
                    "children": [
                        {
                            "id": "${newId()}",
                            "type": "fx-button-group",
                            "props": {
                                "showDropdown": false,
                                "dataset":"${layout.cardMaster[0].dataset}"
                            },
                            "slots": {
                                "default": [
                                    {
                                        "type": "fx-button",
                                        "props": {
                                            "label": "保存",
                                            "leftIcon": "save",
                                            "type": "success",
                                            "action": "button:saveCard"
                                        },
                                        "id": "${newId()}",
                                        "events": {}
                                    },
                                    {
                                        "type": "fx-button",
                                        "props": {
                                            "label": "删除",
                                            "leftIcon": "delete",
                                            "type": "danger",
                                            "action": "button:delCard"
                                        },
                                        "id": "${newId()}",
                                        "events": {}
                                    },
                                    {
                                        "type": "fx-button",
                                        "props": {
                                            "label": "返回",
                                            "leftIcon": "return",
                                            "action": "button:backList"
                                        },
                                        "id": "${newId()}",
                                        "events": {}
                                    }
                                ],
                                "dropdown": []
                            }
                        }
                    ]
                },
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "alignX": "stretch",
                        "size": "0"
                    },
                     "children": [
                        {
                            "id": "${newId()}",
                            "type": "fx-divider",
                            "props": {
                                "label": "",
                                "contentPosition": "center",
                                "direction": "horizontal"
                            }
                        }
                     ]
                },
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "size": "0",
                        "paddingTop": 15,
                        "colNum": "${param.masterCol}"
                    },
                    <#assign mfields = layout.cardMaster[0].fields>
                    "children": [
                        <#list mfields as mfield>
                            {
                                "id": "id${newId()}",
                                <#if (mfield.readonly = true)>
                                    "type": "fx-text",
                                    "disabled": true,
                                <#else>
                                    "type": "${mfield.editor}",
                                </#if>
                                "props": {
                                    "label": "${mfield.label}",
                                    "dataset": "${mfield.dataset}",
                                    "field": "${mfield.id}",
                                    "required": "${mfield.required}",
                                    <#if mfield.maxlength gt 0>
                                        "maxlength": ${mfield.maxlength},
                                    </#if>
                                    "placeholder": "请输入${mfield.label}",
                                    <#if (param.masterCol gte 2)>
                                        "tips": "${mfield.desc}",
                                    </#if>
                                    "labelWidth": 100,
                                    <#if (mfield.readonly = true)>
                                        "readonly": true,
                                    <#else>
                                        "readonly": false,
                                    </#if>
                                    "affixError": true
                                },
                                "events": {}
                            }
                            <#if mfield_has_next>
                                <#if (param.masterCol lte 1 )>
                                    <#if (mfield.desc != "")>
                                        ,{
                                            "id": "id${newId()}",
                                            "type": "fx-label",
                                            "props": {
                                                "label": "${mfield.desc}",
                                                "labelWidth": 0,
                                                "affixError": true,
                                                "labelAlign": "left"
                                            }
                                        }
                                    <#else>
                                        ,{
                                            "id": "id${newId()}",
                                            "type": "fx-placeholder",
                                            "props": {
                                                "label": "占位"
                                            },
                                            "layout": {
                                                "row": 1
                                            }
                                        }
                                    </#if>
                                </#if>
                            ,
                            </#if>
                        </#list>
                    ]
                },
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "size": "0"
                    },
                    "children": [
                        {
                            "id": "${newId()}",
                            "type": "fx-divider",
                            "props": {
                                "label": "",
                                "contentPosition": "center",
                                "direction": "horizontal"
                            }
                        }
                    ]
                },
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "size": "50",
                        "alignX": "end",
                        "alignY": "center",
                        "paddingRight": 20,
                        "colNum": 2,
                        "gridTemplateColumns": "92px 1fr"
                    },
                    "children": [
                        {
                            "id": "${newId()}",
                            "type": "fx-title",
                            "props": {
                                <#if (param.listSubTitle == "")>
                                    "label": "明细列表",
                                <#else>
                                    "label": "${param.listSubTitle}",
                                </#if>
                                "fontWeight": "bold",
                                "showPrefix": true,
                                "fontSize": 16,
                                "prefixWidth": 5
                            }
                        },
                        {
                            "id": "${newId()}",
                            "type": "fx-button-group",
                            "props": {
                                "showDropdown": false
                            },
                            "slots": {
                                "default": [
                                    {
                                        "type": "fx-button",
                                        "props": {
                                            "label": "新增",
                                            "leftIcon": "plus",
                                            "type": "primary",
                                            "action": "button:addRow",
                                            "linkType": "dialog",
                                            "fxLink": "dialog:cardSubDialog",
                                            "fxLink_text": "子表编辑卡片",
                                            "nextAction": "",
                                            "preAction": "",
                                            "dataset": "${layout.listSub[0].dataset}"
                                        },
                                        "id": "${newId()}",
                                        "events": {}
                                    }
                                ],
                                "dropdown": []
                            }
                        }
                    ]
                },
                <#assign group = layout.listSub[0]>
                <#include "incModel/inc_clist_ms.ftl"/>
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "size": "15",
                        "backgroundColor": "transparent"
                    },
                    "children": []
                }
            ]
          }
        ]
      }
    },
    {
        "page": {
            "id": "${newId()}",
            "type": "fx-dialog",
            "props": {
                "title": "子表编辑卡片",
                "key": "cardSubDialog",
                "width": "670px",
                "height": "560px",
                "showPrefix": true
            },
            "events": {}
        },
        "graph": {
            "shape": "panel",
            "id": "root_panel",
            "type": "fx-split-panel",
            "props": {
                "horizontal": false,
                "shadow": "never"
            },
            "children": [
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "size": "50",
                        "alignX": "start",
                        "alignY": "center",
                        "paddingLeft": 20
                    },
                    "children": [
                        {
                            "id": "${newId()}",
                            "type": "fx-title",
                            "props": {
                                <#if (param.cardSubTitle == "")>
                                    "label": "明细编辑",
                                <#else>
                                    "label": "${param.cardSubTitle}",
                                </#if>
                                "fontWeight": "bold",
                                "fontSize": 16,
                                "showPrefix": true
                            }
                        }
                    ]
                },
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "paddingLeft": 50,
                        "colNum": "${param.subCol}"
                    },
                    <#assign sfields = layout.listSub[0].fields>
                    "children": [
                        <#list sfields as sfield>
                            {
                                "id": "id${newId()}",
                                <#if (sfield.readonly = true)>
                                    "type": "fx-text",
                                    "disabled": true,
                                <#else>
                                    "type": "${sfield.editor}",
                                </#if>
                                "props": {
                                    "label": "${sfield.label}",
                                    "dataset": "${sfield.dataset}",
                                    "field": "${sfield.id}",
                                    "required": "${sfield.required}",
                                    <#if sfield.maxlength gt 0>
                                        "maxlength": ${sfield.maxlength},
                                    </#if>
                                    "placeholder": "请输入${sfield.label}",
                                    <#if (param.subCol gte 2)>
                                        "tips": "${sfield.desc}",
                                    </#if>
                                    "labelWidth": 100,
                                    <#if (sfield.readonly = true)>
                                        "readonly": true,
                                    <#else>
                                        "readonly": false,
                                    </#if>
                                    "affixError": true
                                },
                                "events": {}
                            }
                            <#if sfield_has_next>
                                <#if (param.subCol lte 1 )>
                                    <#if (sfield.desc != "")>
                                        ,{
                                            "id": "id${newId()}",
                                            "type": "fx-label",
                                            "props": {
                                                "label": "${sfield.desc}",
                                                "labelWidth": 0,
                                                "affixError": true,
                                                "labelAlign": "left"
                                            }
                                        }
                                    <#else>
                                        ,{
                                            "id": "id${newId()}",
                                            "type": "fx-placeholder",
                                            "props": {
                                                "label": "占位"
                                            },
                                            "layout": {
                                                "row": 1
                                            }
                                        }
                                    </#if>
                                </#if>
                            ,
                            </#if>
                        </#list>
                    ]
                },
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "size": "0"
                    },
                    "children": [
                        {
                            "id": "${newId()}",
                            "type": "fx-divider",
                            "props": {
                                "label": "",
                                "contentPosition": "center",
                                "direction": "horizontal"
                            }
                        }
                    ]
                },
                {
                    "id": "${newId()}",
                    "type": "fx-form-panel",
                    "shape": "panel",
                    "props": {
                        "size": "50",
                        "alignX": "end",
                        "paddingRight": 20,
                        "alignY": "center"
                    },
                    "children": [
                        {
                            "id": "${newId()}",
                            "type": "fx-button-group",
                            "props": {
                                "showDropdown": false
                            },
                            "slots": {
                                "default": [
                                    {
                                        "type": "fx-button",
                                        "props": {
                                            "label": "保存",
                                            "leftIcon": "save",
                                            "type": "success",
                                            "action": "button:saveRow",
                                            "dataset": "${layout.listSub[0].dataset}",
                                            "nextAction": "button:closeDialog"
                                        },
                                        "id": "${newId()}",
                                        "events": {}
                                    },
                                    {
                                        "type": "fx-button",
                                        "props": {
                                            "label": "保存并新增",
                                            "type": "primary",
                                            "action": "button:saveRow",
                                            "linkType": "curr",
                                            "dataset": "${layout.listSub[0].dataset}",
                                            "nextAction": "button:addRow"
                                        },
                                        "id": "${newId()}",
                                        "events": {}
                                    },
                                    {
                                        "type": "fx-button",
                                        "props": {
                                            "label": "返回",
                                            "leftIcon": "return",
                                            "action": "button:closeDialog"
                                        },
                                        "id": "${newId()}",
                                        "events": {}
                                    }
                                ],
                                "dropdown": []
                            }
                        }
                    ]
                }
            ]
        }
    }
  ],
  "model": [
    <#list datasets as dataset>
        <#include "incModel/inc_model.ftl"/><#if dataset_has_next>,</#if>
    </#list>
  ],
  "option": {
    "widgetRef": [${widgetRef}],
    "vars": []
  }
}
