{
  "version": 6,
  "form": [
    {
      "page": {
        "id": "id${newId()}",
        "type": "fx-page",
        "props": {
          "title": "${title}",
          "key": "${newId()}",
          "tipsExpand": false
        }
      },
      "graph": {
        "shape": "panel",
        "id": "root_panel",
        "type": "fx-split-panel",
        "props": {
          "horizontal": false,
          "shadow": "never"
        },
        "children": [
          {
            "id": "${newId()}",
            "type": "fx-split-panel",
            "shape": "panel",
            "props": {
              "size": "60"
            },
            "children": [
              {
                "id": "${newId()}",
                "type": "fx-button-group",
                "props": {
                  "showDropdown": false,
                  "dataset":"${layout.card[0].dataset}"
                },
                "slots": {
                  "default": [
                    {
                      "type": "fx-button",
                      "props": {
                        "label": "保存",
                        "leftIcon": "save",
                        "type": "success",
                        "action": "button:saveCard"
                      },
                      "id": "${newId()}",
                      "events": {}
                    },
                    {
                      "type": "fx-button",
                      "props": {
                        "label": "删除",
                        "leftIcon": "delete",
                        "type": "danger",
                        "action": "button:delCard"
                      },
                      "id": "${newId()}",
                      "events": {}
                    },
                    {
                      "type": "fx-button",
                      "props": {
                        "label": "返回",
                        "leftIcon": "return",
                        "action": "button:backList"
                      },
                      "id": "${newId()}",
                      "events": {}
                    }
                  ],
                  "dropdown": []
                }
              }
            ]
          },
          {
            "id": "${newId()}",
            "type": "fx-form-panel",
            "shape": "panel",
            "props": {
                "colNum": "${param.col}"
            },
            <#assign dfields = layout.card[0].fields>
            "children": [
            <#list dfields as dfield>
                {
                    "id": "id${newId()}",
                    <#if (dfield.readonly = true)>
                        "type": "fx-text",
                        "disabled": true,
                    <#else>
                        "type": "${dfield.editor}",
                    </#if>
                    "props": {
                        "label": "${dfield.label}",
                        "dataset": "${dfield.dataset}",
                        "field": "${dfield.id}",
                        "required": "${dfield.required}",
                        <#if dfield.maxlength gt 0>
                          "maxlength": ${dfield.maxlength},
                        </#if>
                        "placeholder": "请输入${dfield.label}",
                        <#if (param.col gte 2)>
                          "tips": "${dfield.desc}",
                        </#if>
                        "labelWidth": 100,
                        <#if (dfield.readonly = true)>
                         "readonly": true,
                        <#else>
                         "readonly": false,
                        </#if>
                        "affixError": true
                    },
                    "events": {}
                }
                <#if dfield_has_next>
                    <#if (param.col lte 1 )>
                        <#if (dfield.desc != "")>
                            ,{
                                "id": "id${newId()}",
                                "type": "fx-label",
                                "props": {
                                    "label": "${dfield.desc}",
                                    "labelWidth": 0,
                                    "affixError": true,
                                    "labelAlign": "left"
                                }
                            }
                        <#else>
                            ,{
                                "id": "id${newId()}",
                                "type": "fx-placeholder",
                                "props": {
                                    "label": "占位"
                                },
                                "layout": {
                                    "row": 1
                                }
                            }
                        </#if>
                    </#if>
                ,
                </#if>
            </#list>
            ]
          }
        ]
      }
    }
  ],
  "model": [
    <#list datasets as dataset>
        <#include "incModel/inc_model.ftl"/><#if dataset_has_next>,</#if>
    </#list>
  ],
  "option": {
    "widgetRef": [${widgetRef}],
    "vars": []
  }
}
